<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/3_Game/Systems/FSMBase.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.18.155069</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('da/d51/_f_s_m_base_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">FSMBase.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../da/d51/_f_s_m_base_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#ac8626acc836a8c975ce232e0b14752a7">    1</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../da/d51/_f_s_m_base_8c.html#ac8626acc836a8c975ce232e0b14752a7">fsmbDebugPrint</a> (<span class="keywordtype">string</span> s)</div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span>{</div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span>    <span class="comment">//Print(&quot;&quot; + s); // comment/uncomment to hide/see debug logs</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span>}</div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#ae1ba270d76591473b3cf762605165762">    5</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../da/d51/_f_s_m_base_8c.html#ae1ba270d76591473b3cf762605165762">fsmbDebugSpam</a> (<span class="keywordtype">string</span> s)</div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span>{</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span>    <span class="comment">//Print(&quot;&quot; + s); // comment/uncomment to hide/see debug spam</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>}</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span> </div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html">   14</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt;<a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMStateBase, <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMEventBase, <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMActionBase, <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMGuardBase&gt;</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>{</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a4b99d3669ae36d55bf3fb5aa815c98ef">   16</a></span>    ref FSMStateBase <a class="code hl_variable" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a4b99d3669ae36d55bf3fb5aa815c98ef">m_srcState</a>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#af93653293b92e38dcb9cf69d3e86f010">   17</a></span>    ref FSMEventBase <a class="code hl_variable" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#af93653293b92e38dcb9cf69d3e86f010">m_event</a>; <span class="comment">// @NOTE: NULL event means &quot;completion transition&quot; in UML speak</span></div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a0d875fcc6b297faf569f72eb445a7c46">   18</a></span>    ref FSMStateBase <a class="code hl_variable" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a0d875fcc6b297faf569f72eb445a7c46">m_dstState</a>; <span class="comment">// @NOTE: NULL dst state == UML terminate pseudonode</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a7c8a1b817c1b52b7696620f98cfd8131">   19</a></span>    ref FSMActionBase <a class="code hl_variable" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a7c8a1b817c1b52b7696620f98cfd8131">m_action</a>;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#aa5c35042c5d584ff252463d76e5291db">   20</a></span>    ref FSMGuardBase <a class="code hl_variable" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#aa5c35042c5d584ff252463d76e5291db">m_guard</a>;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a5e711a82ad34f8d8de7b69899fd22e2f">   22</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a5e711a82ad34f8d8de7b69899fd22e2f">FSMTransition</a> (FSMStateBase src, FSMEventBase e, FSMStateBase dst, FSMActionBase a = NULL, FSMGuardBase g = NULL)</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    {</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        m_srcState = src;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>        <a class="code hl_variable" href="../../da/ddc/_day_z_player_inventory_8c.html#a813d629d73e4b6b34443ec681a50fce7">m_event</a> = e;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        m_dstState = dst;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        <a class="code hl_variable" href="../../dd/db3/_weapon_chambering_8c.html#a9088984af4ef30aa23a15d4c50db9458">m_action</a> = a;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        m_guard = g;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    }</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>};</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">   32</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a></div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>{</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fad209f16386a8c02d17e1667449b46e65">   34</a></span>    <a class="code hl_enumvalue" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fad209f16386a8c02d17e1667449b46e65">FSM_OK</a>,</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fae2c4b43e97615b4e4b07100460041bcc">   35</a></span>    <a class="code hl_enumvalue" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fae2c4b43e97615b4e4b07100460041bcc">FSM_TERMINATED</a>,</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fa24ef4d117dbf6e34efff804b18560c0c">   36</a></span>    <a class="code hl_enumvalue" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fa24ef4d117dbf6e34efff804b18560c0c">FSM_ABORTED</a>,</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29faec8582ef0f41923c199d01951a05abbd">   37</a></span>    <a class="code hl_enumvalue" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29faec8582ef0f41923c199d01951a05abbd">FSM_NO_TRANSITION</a>,</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>};</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html">   46</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#dc/d01/class_f_s_m_base">FSMBase</a>&lt;<a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMStateBase, <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMEventBase, <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMActionBase, <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a> FSMGuardBase&gt;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>{</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a87e26486282f14a67ba59ca6bdc8a3d3">   48</a></span>    <span class="keyword">protected</span> ref FSMStateBase <a class="code hl_variable" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a87e26486282f14a67ba59ca6bdc8a3d3">m_state</a>; </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a7ecc10a585d01c26d94f83f5e25b63bc">   49</a></span>    <span class="keyword">protected</span> ref FSMStateBase <a class="code hl_variable" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a7ecc10a585d01c26d94f83f5e25b63bc">m_initialState</a>; </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a977d7437e0b2b42347da75b35b48c1eb">   50</a></span>    <span class="keyword">protected</span> ref FSMEventBase <a class="code hl_variable" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a977d7437e0b2b42347da75b35b48c1eb">m_initialEvent</a>; </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#abf9c7c497b55d4f1bfb46ab328b1446d">   51</a></span>    <span class="keyword">protected</span> ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref FSMTransition&lt;FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase&gt;</a>&gt; <a class="code hl_variable" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#abf9c7c497b55d4f1bfb46ab328b1446d">m_transitions</a>; </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a3c55ea60a17a57c25fa4140caec53e73">   53</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a3c55ea60a17a57c25fa4140caec53e73">FSMBase</a> ()</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>    {</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        m_transitions = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref FSMTransition&lt;FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase&gt;</a>&gt;;</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>    }</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span> </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a539f4e1e78c0b6916c3595c291b77e4b">   62</a></span>    FSMStateBase <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a539f4e1e78c0b6916c3595c291b77e4b">GetCurrentState</a> ()</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    {</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <span class="keywordflow">return</span> m_state;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>    }</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#aa98d0a489e1058b003f2b69cf061547c">   70</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#aa98d0a489e1058b003f2b69cf061547c">SetInitialState</a> (FSMStateBase initial_state)</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    {</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        m_initialState = initial_state;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>    }</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a736dca685a44ccb5612503c124768d31">   79</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a736dca685a44ccb5612503c124768d31">Start</a> (FSMEventBase initial_event = NULL)</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>    {</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        <a class="code hl_function" href="../../da/d51/_f_s_m_base_8c.html#ac8626acc836a8c975ce232e0b14752a7">fsmbDebugPrint</a>(<span class="stringliteral">&quot;[fsm] &quot;</span> + this.<a class="code hl_function" href="../../d0/d13/_en_convert_8c.html#afa7657e4f6687b78bc860ddff41c3bef">ToString</a>() + <span class="stringliteral">&quot;::Start(&quot;</span> + initial_event.<a class="code hl_function" href="../../d5/da2/group___strings.html#ga2aa07a41b8fd7270be668acdf9486a87">ToString</a>() + <span class="stringliteral">&quot;), init_state=&quot;</span> + m_initialState.<a class="code hl_function" href="../../d5/da2/group___strings.html#ga2aa07a41b8fd7270be668acdf9486a87">ToString</a>());</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        m_state = m_initialState;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        m_state.OnEntry(initial_event);</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    }</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a4456ade362814308b5d1488c32bb6b1d">   90</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a4456ade362814308b5d1488c32bb6b1d">IsRunning</a> () { <span class="keywordflow">return</span> m_state != NULL; }</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a66600c522c0ce4dda85043a1c2428dec">   95</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a66600c522c0ce4dda85043a1c2428dec">Terminate</a> (FSMEventBase terminal_event = NULL)</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>    {</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d9/dc3/group___tools.html#ga503e3d34e944eb2100a9b6e26cde2aae">IsRunning</a>())</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        {</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>            m_state.OnExit(terminal_event);</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>            m_state = NULL;</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        }</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>    }</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span> </div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#ac9e320782e7b46efc0fb993cad044ac9">  107</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#ac9e320782e7b46efc0fb993cad044ac9">Update</a> (<span class="keywordtype">float</span> dt)</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    {</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d9/dc3/group___tools.html#ga503e3d34e944eb2100a9b6e26cde2aae">IsRunning</a>())</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>            m_state.OnUpdate(dt);</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>    }</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    </div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#af4959372683a2ac257f32948d160f029">  116</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#af4959372683a2ac257f32948d160f029">AddTransition</a> (<a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition&lt;FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase&gt;</a> t)</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>    {</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        m_transitions.Insert(t);</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>    }</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a34d943ab0d26a17fe9cb2a54ca23f53a">  126</a></span>    <a class="code hl_enumeration" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a34d943ab0d26a17fe9cb2a54ca23f53a">ProcessEvent</a> (FSMEventBase e)</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    {</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>        FSMStateBase curr_state = m_state;</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span> </div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <span class="keywordtype">int</span> count = m_transitions.Count();</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; count; ++i)</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        {</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>            <a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition&lt;FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase&gt;</a> row = m_transitions.Get(i);</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            <span class="keywordflow">if</span> (row.m_srcState.Type() == curr_state.Type() &amp;&amp; row.m_event.Type() == e.Type())</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>            {</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>                <a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition&lt;FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase&gt;</a> t = m_transitions.Get(i);</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>                <span class="keywordtype">bool</span> hasGuard = t.m_guard != NULL;</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>                <span class="keywordflow">if</span> (!hasGuard || (hasGuard &amp;&amp; t.m_guard.GuardCondition(e)))     <span class="comment">// 1) exec guard (if any)</span></div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>                {</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>                    ProcessLocalTransition(t, e); <span class="comment">// 2) process transition allowed by guard</span></div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>                }</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>            }</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        }</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a>.FSM_NO_TRANSITION;</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>    }</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno"><a class="line" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#ab5f065855bc69b839d47ca8ead43e3c4">  153</a></span>    <span class="keyword">protected</span> <a class="code hl_enumeration" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a> <a class="code hl_function" href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#ab5f065855bc69b839d47ca8ead43e3c4">ProcessLocalTransition</a> (<a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition&lt;FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase&gt;</a> t, FSMEventBase e)</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>    {</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        <a class="code hl_function" href="../../da/d51/_f_s_m_base_8c.html#ac8626acc836a8c975ce232e0b14752a7">fsmbDebugPrint</a>(<span class="stringliteral">&quot;[fsm] (local) state=&quot;</span> + t.m_srcState.ToString() + <span class="stringliteral">&quot;-------- event=&quot;</span> + e.ToString() + <span class="stringliteral">&quot;[G=&quot;</span> + t.m_guard.ToString() +<span class="stringliteral">&quot;]/A=&quot;</span> + t.m_action.ToString() + <span class="stringliteral">&quot; --------|&gt; dst=&quot;</span> + t.m_dstState.ToString());</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        m_state.OnExit(e);          <span class="comment">// 1) call onExit on old state</span></div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span> </div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        <span class="keywordflow">if</span> (t.m_action)</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>            t.m_action.Action(e);   <span class="comment">// 2) execute transition action (if any)</span></div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span> </div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        m_state = t.m_dstState;     <span class="comment">// 3) change state to new</span></div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span> </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        <span class="keywordflow">if</span> (t.m_dstState != NULL)</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        {</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>            m_state.OnEntry(e);     <span class="comment">// 4a) call onEntry on new state</span></div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>            <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a>.FSM_OK;</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        }</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        {</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>            <a class="code hl_function" href="../../da/d51/_f_s_m_base_8c.html#ac8626acc836a8c975ce232e0b14752a7">fsmbDebugPrint</a>(<span class="stringliteral">&quot;[fsm] terminating fsm: state=&quot;</span> + t.m_srcState.ToString() + <span class="stringliteral">&quot; event=&quot;</span> + e.ToString());</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>            <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a>.FSM_TERMINATED; <span class="comment">// 4b) or terminate</span></div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>        }</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>    }</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>};</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span> </div>
<div class="ttc" id="a_day_z_player_inventory_8c_html_a813d629d73e4b6b34443ec681a50fce7"><div class="ttname"><a href="../../da/ddc/_day_z_player_inventory_8c.html#a813d629d73e4b6b34443ec681a50fce7">m_event</a></div><div class="ttdeci">ref HandEventBase m_event</div><div class="ttdef"><b>Definition:</b> <a href="../../da/ddc/_day_z_player_inventory_8c_source.html#l00113">DayZPlayerInventory.c:113</a></div></div>
<div class="ttc" id="a_en_convert_8c_html_afa7657e4f6687b78bc860ddff41c3bef"><div class="ttname"><a href="../../d0/d13/_en_convert_8c.html#afa7657e4f6687b78bc860ddff41c3bef">ToString</a></div><div class="ttdeci">proto string ToString()</div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_a09f6ec45b8f9309647a7b1eb893bc29f"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a></div><div class="ttdeci">ProcessEventResult</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00032">FSMBase.c:33</a></div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_a09f6ec45b8f9309647a7b1eb893bc29fa24ef4d117dbf6e34efff804b18560c0c"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fa24ef4d117dbf6e34efff804b18560c0c">FSM_ABORTED</a></div><div class="ttdeci">@ FSM_ABORTED</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00036">FSMBase.c:36</a></div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_a09f6ec45b8f9309647a7b1eb893bc29fad209f16386a8c02d17e1667449b46e65"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fad209f16386a8c02d17e1667449b46e65">FSM_OK</a></div><div class="ttdeci">@ FSM_OK</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00034">FSMBase.c:34</a></div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_a09f6ec45b8f9309647a7b1eb893bc29fae2c4b43e97615b4e4b07100460041bcc"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29fae2c4b43e97615b4e4b07100460041bcc">FSM_TERMINATED</a></div><div class="ttdeci">@ FSM_TERMINATED</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00035">FSMBase.c:35</a></div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_a09f6ec45b8f9309647a7b1eb893bc29faec8582ef0f41923c199d01951a05abbd"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29faec8582ef0f41923c199d01951a05abbd">FSM_NO_TRANSITION</a></div><div class="ttdeci">@ FSM_NO_TRANSITION</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00037">FSMBase.c:37</a></div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_ac8626acc836a8c975ce232e0b14752a7"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#ac8626acc836a8c975ce232e0b14752a7">fsmbDebugPrint</a></div><div class="ttdeci">void fsmbDebugPrint(string s)</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00001">FSMBase.c:1</a></div></div>
<div class="ttc" id="a_f_s_m_base_8c_html_ae1ba270d76591473b3cf762605165762"><div class="ttname"><a href="../../da/d51/_f_s_m_base_8c.html#ae1ba270d76591473b3cf762605165762">fsmbDebugSpam</a></div><div class="ttdeci">void fsmbDebugSpam(string s)</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00005">FSMBase.c:5</a></div></div>
<div class="ttc" id="a_weapon_chambering_8c_html_a9088984af4ef30aa23a15d4c50db9458"><div class="ttname"><a href="../../dd/db3/_weapon_chambering_8c.html#a9088984af4ef30aa23a15d4c50db9458">m_action</a></div><div class="ttdeci">class WeaponEndAction extends WeaponStartAction m_action</div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a34d943ab0d26a17fe9cb2a54ca23f53a"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a34d943ab0d26a17fe9cb2a54ca23f53a">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::ProcessEvent</a></div><div class="ttdeci">ProcessEventResult ProcessEvent(FSMEventBase e)</div><div class="ttdoc">instructs the state machine to process the event e</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00126">FSMBase.c:126</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a3c55ea60a17a57c25fa4140caec53e73"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a3c55ea60a17a57c25fa4140caec53e73">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::FSMBase</a></div><div class="ttdeci">void FSMBase()</div><div class="ttdoc">fsm transition table</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00053">FSMBase.c:53</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a4456ade362814308b5d1488c32bb6b1d"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a4456ade362814308b5d1488c32bb6b1d">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::IsRunning</a></div><div class="ttdeci">bool IsRunning()</div><div class="ttdoc">returns true if machine is in running state</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00090">FSMBase.c:90</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a539f4e1e78c0b6916c3595c291b77e4b"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a539f4e1e78c0b6916c3595c291b77e4b">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::GetCurrentState</a></div><div class="ttdeci">FSMStateBase GetCurrentState()</div><div class="ttdoc">returns currently active state</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00062">FSMBase.c:62</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a66600c522c0ce4dda85043a1c2428dec"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a66600c522c0ce4dda85043a1c2428dec">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::Terminate</a></div><div class="ttdeci">void Terminate(FSMEventBase terminal_event=NULL)</div><div class="ttdoc">terminates the state machine</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00095">FSMBase.c:95</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a736dca685a44ccb5612503c124768d31"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a736dca685a44ccb5612503c124768d31">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::Start</a></div><div class="ttdeci">void Start(FSMEventBase initial_event=NULL)</div><div class="ttdoc">starts the state machine by entering the initial_state (using intial_event as argument to initial sta...</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00079">FSMBase.c:79</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a7ecc10a585d01c26d94f83f5e25b63bc"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a7ecc10a585d01c26d94f83f5e25b63bc">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_initialState</a></div><div class="ttdeci">protected ref FSMStateBase m_initialState</div><div class="ttdoc">current fsm state</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00049">FSMBase.c:49</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a87e26486282f14a67ba59ca6bdc8a3d3"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a87e26486282f14a67ba59ca6bdc8a3d3">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_state</a></div><div class="ttdeci">protected ref FSMStateBase m_state</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00048">FSMBase.c:48</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_a977d7437e0b2b42347da75b35b48c1eb"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#a977d7437e0b2b42347da75b35b48c1eb">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_initialEvent</a></div><div class="ttdeci">protected ref FSMEventBase m_initialEvent</div><div class="ttdoc">configurable initial state of the machine</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00050">FSMBase.c:50</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_aa98d0a489e1058b003f2b69cf061547c"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#aa98d0a489e1058b003f2b69cf061547c">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::SetInitialState</a></div><div class="ttdeci">void SetInitialState(FSMStateBase initial_state)</div><div class="ttdoc">sets the initial_state for starting the machine</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00070">FSMBase.c:70</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_ab5f065855bc69b839d47ca8ead43e3c4"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#ab5f065855bc69b839d47ca8ead43e3c4">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::ProcessLocalTransition</a></div><div class="ttdeci">protected ProcessEventResult ProcessLocalTransition(FSMTransition&lt; FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase &gt; t, FSMEventBase e)</div><div class="ttdoc">instructs the state machine to process the event locally - no hierarchy is crossed</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00153">FSMBase.c:153</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_abf9c7c497b55d4f1bfb46ab328b1446d"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#abf9c7c497b55d4f1bfb46ab328b1446d">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_transitions</a></div><div class="ttdeci">protected ref array&lt; ref FSMTransition&lt; FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase &gt; &gt; m_transitions</div><div class="ttdoc">configurable initial event to start the machine (null by default)</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00051">FSMBase.c:51</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_ac9e320782e7b46efc0fb993cad044ac9"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#ac9e320782e7b46efc0fb993cad044ac9">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::Update</a></div><div class="ttdeci">void Update(float dt)</div><div class="ttdoc">if machine running, call OnUpdate() on current state</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00107">FSMBase.c:107</a></div></div>
<div class="ttc" id="aclass_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89_html_af4959372683a2ac257f32948d160f029"><div class="ttname"><a href="../../d8/d1b/class_f_s_m_base_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_class_01_ff05bd52b3b493f858f7641b9988f4c89.html#af4959372683a2ac257f32948d160f029">FSMBase&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::AddTransition</a></div><div class="ttdeci">void AddTransition(FSMTransition&lt; FSMStateBase, FSMEventBase, FSMActionBase, FSMGuardBase &gt; t)</div><div class="ttdoc">adds transition into transition table</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00116">FSMBase.c:116</a></div></div>
<div class="ttc" id="aclass_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5_html_a0d875fcc6b297faf569f72eb445a7c46"><div class="ttname"><a href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a0d875fcc6b297faf569f72eb445a7c46">FSMTransition&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_dstState</a></div><div class="ttdeci">ref FSMStateBase m_dstState</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00018">FSMBase.c:18</a></div></div>
<div class="ttc" id="aclass_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5_html_a4b99d3669ae36d55bf3fb5aa815c98ef"><div class="ttname"><a href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a4b99d3669ae36d55bf3fb5aa815c98ef">FSMTransition&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_srcState</a></div><div class="ttdeci">ref FSMStateBase m_srcState</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00016">FSMBase.c:16</a></div></div>
<div class="ttc" id="aclass_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5_html_a5e711a82ad34f8d8de7b69899fd22e2f"><div class="ttname"><a href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a5e711a82ad34f8d8de7b69899fd22e2f">FSMTransition&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::FSMTransition</a></div><div class="ttdeci">void FSMTransition(FSMStateBase src, FSMEventBase e, FSMStateBase dst, FSMActionBase a=NULL, FSMGuardBase g=NULL)</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00022">FSMBase.c:22</a></div></div>
<div class="ttc" id="aclass_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5_html_a7c8a1b817c1b52b7696620f98cfd8131"><div class="ttname"><a href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#a7c8a1b817c1b52b7696620f98cfd8131">FSMTransition&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_action</a></div><div class="ttdeci">ref FSMActionBase m_action</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00019">FSMBase.c:19</a></div></div>
<div class="ttc" id="aclass_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5_html_aa5c35042c5d584ff252463d76e5291db"><div class="ttname"><a href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#aa5c35042c5d584ff252463d76e5291db">FSMTransition&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_guard</a></div><div class="ttdeci">ref FSMGuardBase m_guard</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00020">FSMBase.c:20</a></div></div>
<div class="ttc" id="aclass_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5_html_af93653293b92e38dcb9cf69d3e86f010"><div class="ttname"><a href="../../df/d47/class_f_s_m_transition_3_01_class_01_f_s_m_state_base_00_01_class_01_f_s_m_event_base_00_01_clasac7fe161e27eea9843775bf8841ab0c5.html#af93653293b92e38dcb9cf69d3e86f010">FSMTransition&lt; Class FSMStateBase, Class FSMEventBase, Class FSMActionBase, Class FSMGuardBase &gt;::m_event</a></div><div class="ttdeci">ref FSMEventBase m_event</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d51/_f_s_m_base_8c_source.html#l00017">FSMBase.c:17</a></div></div>
<div class="ttc" id="aclassarray_html"><div class="ttname"><a href="../../d2/d41/classarray.html">array</a></div><div class="ttdoc">Result for an object found in CGame.IsBoxCollidingGeometryProxy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcd/_is_box_colliding_geometry_proxy_classes_8c_source.html#l00027">IsBoxCollidingGeometryProxyClasses.c:28</a></div></div>
<div class="ttc" id="agroup___enforce_html_d4/d14/class_class"><div class="ttname"><a href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a></div><div class="ttdoc">Super root of all classes in Enforce script.</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d15/_en_script_8c_source.html#l00010">EnScript.c:11</a></div></div>
<div class="ttc" id="agroup___strings_html_ga2aa07a41b8fd7270be668acdf9486a87"><div class="ttname"><a href="../../d5/da2/group___strings.html#ga2aa07a41b8fd7270be668acdf9486a87">string::ToString</a></div><div class="ttdeci">static proto string ToString(void var, bool type=false, bool name=false, bool quotes=true)</div><div class="ttdoc">Return string representation of variable.</div></div>
<div class="ttc" id="agroup___tools_html_ga503e3d34e944eb2100a9b6e26cde2aae"><div class="ttname"><a href="../../d9/dc3/group___tools.html#ga503e3d34e944eb2100a9b6e26cde2aae">IsRunning</a></div><div class="ttdeci">bool IsRunning()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/dc2/3___game_2tools_2tools_8c_source.html#l00263">tools.c:263</a></div></div>
<div class="ttc" id="anamespace_3global_scope_4_html_d8/d41/class_f_s_m_transition"><div class="ttname"><a href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a></div><div class="ttdoc">represents transition src -— event[guard]/action -—|&gt; dst</div></div>
<div class="ttc" id="anamespace_3global_scope_4_html_dc/d01/class_f_s_m_base"><div class="ttname"><a href="../../d0/deb/namespace_3global_scope_4.html#dc/d01/class_f_s_m_base">FSMBase</a></div><div class="ttdoc">base class for finite state machine</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_5eccb71dd63ea3c42a1369b85c71c9fd.html">3_Game</a></li><li class="navelem"><a class="el" href="../../dir_91065d8ef1d9d84badd69667faa65040.html">Systems</a></li><li class="navelem"><a class="el" href="../../da/d51/_f_s_m_base_8c.html">FSMBase.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
